VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2505
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   4935
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2505
   ScaleWidth      =   4935
   Begin VB.Frame Frame2 
      Caption         =   "Flags"
      Height          =   1215
      Left            =   0
      TabIndex        =   6
      Top             =   360
      Width           =   4935
      Begin VB.CheckBox chkShortDate 
         Caption         =   "Short Date"
         Height          =   255
         Left            =   240
         TabIndex        =   11
         Top             =   240
         Width           =   1095
      End
      Begin VB.CheckBox chkLongDate 
         Caption         =   "Long Date"
         Height          =   255
         Left            =   240
         TabIndex        =   10
         Top             =   480
         Width           =   1095
      End
      Begin VB.CheckBox chkYearMonth 
         Caption         =   "YearMonth"
         Height          =   255
         Left            =   2760
         TabIndex        =   9
         Top             =   240
         Width           =   1095
      End
      Begin VB.CheckBox chkAltCalendar 
         Caption         =   "Alt Calendar"
         Height          =   255
         Left            =   2760
         TabIndex        =   8
         Top             =   480
         Width           =   1215
      End
      Begin VB.TextBox txtFormat 
         Height          =   285
         Left            =   1800
         TabIndex        =   7
         Top             =   840
         Width           =   1935
      End
      Begin VB.Label lblFormat 
         Caption         =   "Format"
         Height          =   255
         Left            =   1200
         TabIndex        =   12
         Top             =   840
         Width           =   495
      End
   End
   Begin VB.OptionButton optLocale 
      Caption         =   "System Default"
      Height          =   255
      Index           =   0
      Left            =   720
      TabIndex        =   0
      Tag             =   "&H400"
      Top             =   0
      Width           =   1455
   End
   Begin VB.OptionButton optLocale 
      Caption         =   "User Default"
      Height          =   255
      Index           =   1
      Left            =   2160
      TabIndex        =   1
      Tag             =   "&H800"
      Top             =   0
      Width           =   1335
   End
   Begin VB.OptionButton optLocale 
      Caption         =   "Use Overrides"
      Height          =   255
      Index           =   2
      Left            =   3480
      TabIndex        =   2
      Tag             =   "0"
      Top             =   0
      Width           =   1335
   End
   Begin VB.CommandButton cmdFormat 
      Caption         =   "Format"
      Default         =   -1  'True
      Height          =   375
      Left            =   2040
      TabIndex        =   3
      Top             =   1680
      Width           =   855
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Locale:"
      Height          =   195
      Index           =   6
      Left            =   0
      TabIndex        =   5
      Top             =   0
      Width           =   525
   End
   Begin VB.Label lblResult 
      Height          =   315
      Left            =   0
      TabIndex        =   4
      Top             =   2160
      Width           =   4965
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type
Private Const LOCALE_SYSTEM_DEFAULT = &H400
Private Const LOCALE_USER_DEFAULT = &H800
Private Const LOCALE_NOUSEROVERRIDE = &H80000000
Private Const LOCALE_USE_CP_ACP = &H40000000
Private Const DATE_SHORTDATE = &H1
Private Const DATE_LONGDATE = &H2
Private Const DATE_USE_ALT_CALENDAR = &H4
Private Const DATE_YEARMONTH = &H8
Private Const DATE_LTRREADING = &H10
Private Const DATE_RTLREADING = &H20

Private Declare Function GetDateFormat Lib "kernel32.dll" Alias "GetDateFormatA" (ByVal Locale As Long, ByVal dwFlags As Long, lpDate As SYSTEMTIME, ByVal lpFormat As Any, ByVal lpDateStr As String, ByVal cchDate As Long) As Long
Private Declare Sub GetLocalTime Lib "kernel32.dll" (lpSystemTime As SYSTEMTIME)

Private m_Locale As Long

Private Sub chkAltCalendar_Click()
    lblFormat.Enabled = _
        (chkShortDate.Value = vbUnchecked) And _
        (chkLongDate.Value = vbUnchecked) And _
        (chkYearMonth.Value = vbUnchecked) And _
        (chkAltCalendar.Value = vbUnchecked)
    txtFormat.Enabled = lblFormat.Enabled
End Sub

Private Sub chkLongDate_Click()
    lblFormat.Enabled = _
        (chkShortDate.Value = vbUnchecked) And _
        (chkLongDate.Value = vbUnchecked) And _
        (chkYearMonth.Value = vbUnchecked) And _
        (chkAltCalendar.Value = vbUnchecked)
    txtFormat.Enabled = lblFormat.Enabled
End Sub

Private Sub chkShortDate_Click()
    lblFormat.Enabled = _
        (chkShortDate.Value = vbUnchecked) And _
        (chkLongDate.Value = vbUnchecked) And _
        (chkYearMonth.Value = vbUnchecked) And _
        (chkAltCalendar.Value = vbUnchecked)
    txtFormat.Enabled = lblFormat.Enabled
End Sub

Private Sub chkYearMonth_Click()
    lblFormat.Enabled = _
        (chkShortDate.Value = vbUnchecked) And _
        (chkLongDate.Value = vbUnchecked) And _
        (chkYearMonth.Value = vbUnchecked) And _
        (chkAltCalendar.Value = vbUnchecked)
    txtFormat.Enabled = lblFormat.Enabled
End Sub


' Format the text.
Private Sub cmdFormat_Click()
Dim local_time As SYSTEMTIME

    ' Use the time now.
    GetLocalTime local_time

    ' Format the time.
    lblResult.Caption = _
        FormatDate(local_time, _
            m_Locale, _
            chkShortDate.Value = vbChecked, _
            chkLongDate.Value = vbChecked, _
            chkYearMonth.Value = vbChecked, _
            chkAltCalendar.Value = vbChecked)
End Sub

' Format a numeric string.
Private Function FormatDate(system_time As SYSTEMTIME, ByVal locale_id As Long, ByVal short_date As Boolean, ByVal long_date As Boolean, ByVal year_month As Boolean, ByVal alt_calendar As Boolean) As String
Dim flags As Long
Dim buf As String * 200
Dim buflen As Integer

    flags = 0
    If short_date Then flags = flags Or DATE_SHORTDATE
    If long_date Then flags = flags Or DATE_LONGDATE
    If year_month Then flags = flags Or DATE_YEARMONTH
    If alt_calendar Then flags = flags Or DATE_USE_ALT_CALENDAR

    If locale_id = 0 Then
        ' Custom.
        ' See if we need to use a format.
        If (flags = 0) And Len(txtFormat.Text) > 0 Then
            buflen = GetDateFormat(locale_id, flags, _
                system_time, txtFormat.Text, buf, Len(buf))
        Else
            buflen = GetDateFormat(locale_id, flags, _
                system_time, ByVal 0&, buf, Len(buf))
        End If
    Else
        ' Locale.
        buflen = GetDateFormat(locale_id, 0, _
            system_time, ByVal 0&, buf, Len(buf))
    End If

    FormatDate = Left$(buf, buflen)
End Function
Private Sub Form_Load()
    optLocale(0).Value = True
End Sub


Private Sub optLocale_Click(Index As Integer)
    m_Locale = CInt(optLocale(Index).Tag)

Dim enable As Boolean
Dim ctl As Control

    enable = (m_Locale = 0)
    Frame2.Enabled = enable
    For Each ctl In Controls
        If ctl.Container Is Frame2 Then
            ctl.Enabled = enable
        End If
    Next ctl
End Sub

